// AIPollingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIPolling.h"
#include "AIPollingDlg.h"

#include "math.h"

#include "PCIELM4.h"
#pragma comment(lib,"PCIELM4.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

WORD wRtn;
WORD wBoardNo,wChannel,wConfig;

PCIELM4_DEVICE_INFO sDevInfo[MAX_BOARD_NUMBER];
PCIELM4_CARD_INFO sCardInfo[MAX_BOARD_NUMBER];
char szModelName[20]="Unknow Device";

DWORD dwDataNo = 100;
long lAIRate;
//float * fBuffer= new float[dwDataNo];
DWORD *lBuf = new DWORD[1000];
double *fBuf = new double[1000];
float *YS = new float[2];
WORD wCfgcode,iGain;
float fRange;
bool bActive = false ;
long   lmx, lmy;
float  fDeltaX, fDeltaY;
float fRangeMax=5;
float fRangeMin=-5;
float YScaleUP,YScaleDown;
DWORD InVal;



//b[0] = gcne


/////////////////////////////////////////////////////////////////////////////
// CAIPollingDlg dialog

CAIPollingDlg::CAIPollingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAIPollingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAIPollingDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAIPollingDlg::DoDataExchange(CDataExchange* pDX)
{
	
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAIPollingDlg)
	DDX_Control(pDX, IDC_DOVal, m_IDC_DOVal);
	DDX_Control(pDX, IDC_DIVal, m_IDC_DIVal);
	DDX_Control(pDX, IDC_cmdAITrigger, m_IDC_cmdAITrigger);
	DDX_Control(pDX, IDC_tbxDataNum, m_IDC_tbxDataNum);
	DDX_Control(pDX, IDC_COMBO_cbxAICfgCode, m_IDC_COMBO_cbxAICfgCode);
	DDX_Control(pDX, IDC_tbxAutoZeroVal, m_IDC_tbxAutoZeroVal);
	DDX_Control(pDX, IDC_cmdSaveAutozeroVal, m_IDC_cmdSaveAutozeroVal);
	DDX_Control(pDX, IDC_chkAutoZeroEnable, m_IDC_chkAutoZeroEnable);
	DDX_Control(pDX, IDC_yscale1, m_IDC_yscale1);
	DDX_Control(pDX, IDC_yscale0, m_IDC_yscale0);
	DDX_Control(pDX, IDC_optAIFloat, m_IDC_optAIFloat);
	DDX_Control(pDX, IDC_optAIHex, m_IDC_optAIHex);
	DDX_Control(pDX, IDC_tbxAOfreq, m_IDC_tbxAOfreq);
	DDX_Control(pDX, IDC_optDAVol, m_IDC_optDAVol);
	DDX_Control(pDX, IDC_optSin, m_IDC_optSin);
	DDX_Control(pDX, IDC_cmdAOStop, m_IDC_cmdAOStop);
	DDX_Control(pDX, IDC_optDC, m_IDC_optDC);
	DDX_Control(pDX, IDC_Frame1, m_IDC_Frame1);
	DDX_Control(pDX, IDC_optDAhex, m_IDC_optDAhex);
	DDX_Control(pDX, IDC_List1, m_IDC_List1);
	DDX_Control(pDX, IDC_cmdAOCH0, m_IDC_cmdAOCH0);
	DDX_Control(pDX, IDC_lblDACH0Type, m_lblDACH0Type);
	DDX_Control(pDX, IDC_tbxAOCH0Val, m_IDC_tbxAOCH0Val);
	DDX_Control(pDX, IDC_COMBO_cbxAIRate, m_IDC_COMBO_cbxAIRate);
	DDX_Control(pDX, IDC_COMBO_cbxAICh, m_IDC_COMBO_cbxAICh);
	DDX_Control(pDX, IDC_COMBO_cbxBoardNo, m_IDC_COMBO_cbxBoardNo);
	DDX_Control(pDX, IDCANCEL, m_IDCCANCEL);
	DDX_Control(pDX, IDC_PIC_Data, m_IDC_PIC_Data);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAIPollingDlg, CDialog)
	//{{AFX_MSG_MAP(CAIPollingDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_cmdAOCH0, OncmdAOCH0)
	ON_BN_CLICKED(IDC_cmdAOStop, OncmdAOStop)
	ON_BN_CLICKED(IDC_optSin, OnoptSin)
	ON_BN_CLICKED(IDC_optDC, OnoptDC)
	ON_BN_CLICKED(IDC_optDAVol, OnoptDAVol)
	ON_BN_CLICKED(IDC_optDAhex, OnoptDAhex)
	ON_CBN_SELCHANGE(IDC_COMBO_cbxAICh, OnSelchangeCOMBOcbxAICh)
	ON_CBN_SELCHANGE(IDC_COMBO_cbxBoardNo, OnSelchangeCOMBOcbxBoardNo)
	ON_CBN_SELCHANGE(IDC_COMBO_cbxAICfgCode, OnSelchangeCOMBOcbxAICfgCode)
	ON_CBN_SELCHANGE(IDC_COMBO_cbxAIRate, OnSelchangeCOMBOcbxAIRate)
	ON_BN_CLICKED(IDC_optAIFloat, OnoptAIFloat)
	ON_BN_CLICKED(IDC_optAIHex, OnoptAIHex)
	ON_BN_CLICKED(IDC_cmdAITrigger, OncmdAITrigger)
	ON_BN_CLICKED(IDC_chkAutoZeroEnable, OnchkAutoZeroEnable)
	ON_BN_CLICKED(IDC_cmdSaveAutozeroVal, OncmdSaveAutozeroVal)
	ON_BN_CLICKED(IDC_OutputDO, OnOutputDO)
	ON_BN_CLICKED(IDC_InputDI, OnInputDI)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDCANCEL, &CAIPollingDlg::OnBnClickedCancel)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAIPollingDlg message handlers

BOOL CAIPollingDlg::OnInitDialog()
{
	WORD wTotalBoards;
	CString str;
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	//Initial the resource form  Driver
	wRtn=PCIELM4_DriverInit(&wTotalBoards);
	if (wRtn!=0) return wRtn;


	m_IDC_COMBO_cbxBoardNo.Clear();
	//_ltoa( wTotalBoards, string, 10 );
	//SetDlgItemText(IDC_EDIT_TotalBoards, string);
	
	//Get Card Information
	for(WORD wBoardIndex = 0; wBoardIndex<wTotalBoards ; wBoardIndex++)
	{
		wRtn = PCIELM4_GetCardInfo(wBoardIndex,&sDevInfo[wBoardIndex],&sCardInfo[wBoardIndex],szModelName);
		
		str.Format("%d  %s", wBoardIndex, szModelName);
		
		m_IDC_COMBO_cbxBoardNo.AddString(str);
	}
	
	m_IDC_COMBO_cbxAICfgCode.SetCurSel(0);
	m_IDC_COMBO_cbxAIRate.SetCurSel(0);

	for(WORD index = 0; index<100;index++)
	{
		fBuf[index] = 0.0F;
	}
	m_IDC_optDC.SetCheck(1);
	m_IDC_optDAhex.SetCheck(1);
	m_IDC_optAIFloat.SetCheck(1);
	m_IDC_tbxAOCH0Val.SetWindowText("0");
	m_IDC_tbxAOfreq.SetWindowText("10");
	m_IDC_tbxDataNum.SetWindowText("100");
	m_IDC_DOVal.SetWindowText("0");
	m_IDC_DIVal.SetWindowText("0");

/*
	CWnd *pwnd = (CWnd*) GetDlgItem(IDC_PIC_Data);
	CRect rect;
	pwnd->GetClientRect(&rect);
	lmx = rect.left;
	lmy = rect.top + (rect.Height() / 2);
	fDeltaX = (float)(rect.Width() / (float)dwDataNo) ;
	fDeltaY = (float)(rect.Height() / 20.0);
*/
	m_IDC_COMBO_cbxBoardNo.SetCurSel(0);
	OnSelchangeCOMBOcbxBoardNo();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAIPollingDlg::OnPaint() 
{

		CDialog::OnPaint();
		CWnd *pwnd = (CWnd*) GetDlgItem(IDC_PIC_Data);
		CPaintDC dc(pwnd);
		CRect rect;
		pwnd->GetClientRect(&rect);

		lmx = rect.left;
		lmy = rect.top + (rect.Height() / 2);
		fDeltaX = (float)(rect.Width() / (float)dwDataNo) ;
		//if(m_IDC_optAIHex.GetCheck()==1)
	//	{
		switch (m_IDC_COMBO_cbxAICfgCode.GetCurSel())
            {

                case PCIELM4_AI_BI_10V:
                    YScaleUP = 10.0F;
                    YScaleDown = -10.0F;
                    break;

                case PCIELM4_AI_BI_5V:    //1  //Bipolar +/-  5V
                    YScaleUP = 5.0F;
                    YScaleDown = -5.0F;
                    break;

                case PCIELM4_AI_BI_2V5:     //2 //Bipolar +/-  2.5V
                    YScaleUP = 2.5F;
                    YScaleDown = -2.5F;
                    break;

                case PCIELM4_AI_BI_1V25:    //3 //Bipolar +/-  1.25V
                    YScaleUP = 1.25F;
                    YScaleDown = -1.25F;
                    break;

				case 4:
					break;
            }
		if (m_IDC_COMBO_cbxAICfgCode.GetCurSel() == 4 )
		{
			YScaleUP = 227.3F;
            YScaleDown = -227.3F;
		}

		fDeltaY = (float)(rect.Height() / (YScaleUP-YScaleDown));

		
		//}else{
		//fDeltaY = (float)(rect.Height() / (GetDlgItemFloat(IDC_yscale0)-GetDlgItemFloat(IDC_yscale1)));//GetDlgItemFloat
		//fDeltaY = (float)(rect.Height() / (YScaleUP-YScaleDown));
		//}


	    CBrush brushGreen(RGB(0, 255, 0));
        CBrush* pOldBrush = dc.SelectObject(&brushGreen);
		CPen penBlack;
        penBlack.CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
        CPen* pOldPen = dc.SelectObject(&penBlack);

        // draw a thick black rectangle filled with blue
        dc.Rectangle(rect);
		dc.MoveTo(lmx, lmy);
		dc.LineTo(rect.right, lmy);
		CPen penRed;
		penRed.CreatePen(PS_SOLID, 1, RGB(255, 0, 0) );
		dc.SelectObject(&penRed);

		//draw line
		dc.MoveTo(lmx,lmy - (int)(fBuf[0]*fDeltaY));
		for(int index=1; index<(int)dwDataNo; index++) 
		{
			dc.LineTo(lmx + (int)(index*fDeltaX),lmy - (int)(fBuf[index]*fDeltaY));

		}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAIPollingDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}





void CAIPollingDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	wRtn = PCIELM4_DriverClose();
	CDialog::OnCancel();
}

float CAIPollingDlg::GetDlgItemFloat(int nID)
{
	static const int nLength = 10;
	CString str;
	char szStr[nLength];//, * stopstring;
	
	GetDlgItemText(nID, str);
	strcpy(szStr, str.GetBuffer(nLength) );
	return (float)atof(szStr);
}

DWORD CAIPollingDlg::GetDlgItemHex(int nID)
{
	static const int nLength = 10;
	CString str;
	char szStr[nLength], * stopstring;
	
	GetDlgItemText(nID, str);
	strcpy(szStr, str.GetBuffer(nLength) );

	//a=strtoul(szStr,0,16);
	//return a;
	return (DWORD)strtoul( szStr, &stopstring, 16 );
}

void CAIPollingDlg::OncmdAOCH0() 
{
	// TODO: Add your control notification handler code here
	long wDaOutputNum;
    long wIndex ;
	float *fDAVal= new float[512];
	unsigned long *dwDAVal = new unsigned long[512] ;
	wBoardNo = m_IDC_COMBO_cbxBoardNo.GetCurSel();
	long HEXtoInt;

	static const int nLength = 10;
	CString str;
//	char Str_AO_btn[nLength];//, * stopstring;
	GetDlgItemText(IDC_cmdAOCH0, str);
    if (strcmp(str,"Active")==0 ) {
		m_IDC_optDC.EnableWindow(false);
        m_IDC_optDAVol.EnableWindow(false);
        m_IDC_optSin.EnableWindow(false); 
        m_IDC_optDAhex.EnableWindow(false);
    }
	
	wRtn = PCIELM4_ConfigAO(wBoardNo, 0, 0, PCIELM4_AO_BI_10V);
	if (wRtn != PCIELM4_NoErr) {
		MessageBox("Config AO0 Error Error");
    }

    m_IDC_List1.ResetContent();
       
        ////Static
       if (m_IDC_optDC.GetCheck() == 1){

            if (m_IDC_optDAhex.GetCheck() == 1){
                wRtn = PCIELM4_WriteAOVoltageH(wBoardNo, 0, GetDlgItemHex(IDC_tbxAOCH0Val));
            }else{
                wRtn = PCIELM4_WriteAOVoltage(wBoardNo, 0, GetDlgItemFloat(IDC_tbxAOCH0Val));
            }
            if (wRtn != PCIELM4_NoErr) {
                MessageBox("Write AO Error" );
            }
            
        }else{ ////Wave generator

            m_IDC_cmdAOStop.EnableWindow(true);
            m_IDC_cmdAOCH0.EnableWindow(false);
		
            wDaOutputNum = 500;

            if (m_IDC_optDAhex.GetCheck() == 1) {

              HEXtoInt = GetDlgItemHex(IDC_tbxAOCH0Val);
                if (HEXtoInt < 0){
                   HEXtoInt = HEXtoInt + 65535;
                }
                for (wIndex = 0; wIndex <=  wDaOutputNum - 1 ; wIndex++){
                    fDAVal[wIndex] = (float)(((HEXtoInt / 65535.0) * (fRangeMax - fRangeMin) + fRangeMin) * sin((2 * 3.14159 / wDaOutputNum) * wIndex));
                    dwDAVal[wIndex] = (unsigned long)(((fDAVal[wIndex] - fRangeMin) / (fRangeMax - fRangeMin)) * 65535);
                   
					str.Format(_T("%03d  %4x"),wIndex,dwDAVal[wIndex]);
				
					m_IDC_List1.AddString(str);
                }
                ////Start DA Pattern Generatorwith Continuous Mode
                wRtn = PCIELM4_StartAOVoltageALLH(wBoardNo, GetDlgItemFloat(IDC_tbxAOfreq) * (wDaOutputNum), wDaOutputNum, 0, dwDAVal, dwDAVal);
           
			}else{
                for (wIndex = 0 ; wIndex <= wDaOutputNum - 1 ; wIndex++){
                    fDAVal[wIndex] = (float)(GetDlgItemFloat(IDC_tbxAOCH0Val) * sin((2 * 3.14159 / wDaOutputNum) * wIndex)); //+ CSng(Me.tbxOffset.Text)
                    //m_IDC_List1.AddString(Convert.ToString(wIndex) + " " + Convert.ToString(fDAVal[wIndex]));
					
					str.Format(_T("%03d  %.3f"),wIndex,fDAVal[wIndex]);
					m_IDC_List1.AddString(str);//+ " " + fDAVal[wIndex]

                }

                ////Start DA Pattern Generatorwith Continuous Mode
                wRtn = PCIELM4_StartAOVoltageALL(wBoardNo, GetDlgItemFloat(IDC_tbxAOfreq) * (wDaOutputNum), wDaOutputNum, 0,  fDAVal, fDAVal);

            }


            if (wRtn != PCIELM4_NoErr){
				m_IDC_cmdAOStop.EnableWindow(false);
				m_IDC_cmdAOCH0.EnableWindow(true);
                MessageBox("Write AO Error " );
            }
     }
	
}

void CAIPollingDlg::OncmdAOStop() 
{
	// TODO: Add your control notification handler code here

	wRtn = PCIELM4_StopAOALL(wBoardNo);

    m_IDC_cmdAOCH0.EnableWindow(true);

	static const int nLength = 10;
	CString str;
	GetDlgItemText(IDC_cmdAOCH0, str);
    if (strcmp(str,"Active")==0 ) 
	{
		m_IDC_optDC.EnableWindow(true);
        m_IDC_optDAVol.EnableWindow(true);
        m_IDC_optSin.EnableWindow(true); 
        m_IDC_optDAhex.EnableWindow(true);
    }
}

void CAIPollingDlg::OnoptSin() 
{
	// TODO: Add your control notification handler code here
	m_IDC_optSin.SetCheck(1); 
	m_IDC_optDC.SetCheck(0); 
	m_IDC_cmdAOCH0.SetWindowText("Active");
}

void CAIPollingDlg::OnoptDC() 
{
	// TODO: Add your control notification handler code here
	m_IDC_optSin.SetCheck(0); 
	m_IDC_optDC.SetCheck(1); 
	m_IDC_cmdAOCH0.SetWindowText("Output");
}

void CAIPollingDlg::OnoptDAVol() 
{
	// TODO: Add your control notification handler code here
	m_IDC_optDAVol.SetCheck(1); 
	m_IDC_optDAhex.SetCheck(0); 
	m_lblDACH0Type.SetWindowText("V");
}

void CAIPollingDlg::OnoptDAhex() 
{
	// TODO: Add your control notification handler code here
	m_IDC_optDAVol.SetCheck(0); 
	m_IDC_optDAhex.SetCheck(1);
	m_lblDACH0Type.SetWindowText("HEX");
}



void CAIPollingDlg::OnSelchangeCOMBOcbxBoardNo() 
{
	// TODO: Add your control notification handler code here
	WORD wChannelIndex; 
	
	wBoardNo = m_IDC_COMBO_cbxBoardNo.GetCurSel();
	//static const int nLength = 15;
	CString string;

	//Total AI Channel
	m_IDC_COMBO_cbxAICh.Clear();

	for (wChannelIndex = 0; wChannelIndex < sCardInfo[wBoardNo].wAIChannels ;wChannelIndex++)
	{	
		//_ltoa(wChannelIndex,string,10);
	
		//m_IDC_COMBO_cbxAICh.AddString(string);  

		if (wChannelIndex < 4) {
			   string.Format("CH %d [Load Cell]",wChannelIndex);
			   m_IDC_COMBO_cbxAICh.AddString(string);  
               //cbxAICh.Items.Add("CH" + Convert.ToString(AIChIndex) + "[Load Cell]");
        }else{
				string.Format("CH %d [General]",wChannelIndex);
				m_IDC_COMBO_cbxAICh.AddString(string); 
               //cbxAICh.Items.Add("CH" + Convert.ToString(AIChIndex) + "[General]");
        }
    }

	
	m_IDC_COMBO_cbxAICh.SetCurSel(4);
	OnSelchangeCOMBOcbxAICh();
    m_IDC_COMBO_cbxAIRate.SetCurSel(6);
	OnSelchangeCOMBOcbxAIRate();
	m_IDC_COMBO_cbxAICfgCode.SetCurSel(1);
	OnSelchangeCOMBOcbxAICfgCode();
	
	
}

void CAIPollingDlg::OnSelchangeCOMBOcbxAICh() 
{
	// TODO: Add your control notification handler code here
	CString str;

	if (m_IDC_COMBO_cbxAICh.GetCurSel() < 4 ){
            m_IDC_COMBO_cbxAICfgCode.EnableWindow(false);
            iGain = 1000;

            fRangeMax = (float)(0.2273 * iGain );
            fRangeMin = (float)(-0.2273 * iGain );
			str.Format("%.3f",fRangeMax*1.1);
            m_IDC_yscale0.SetWindowText(str); 
            YS[0] = fRangeMax;

			str.Format("%.3f", fRangeMin*1.1);
            m_IDC_yscale1.SetWindowText(str);
            YS[1] = fRangeMin;

            // YScale_LostFocus(0)
            // YScale_LostFocus(1)

            m_IDC_optAIFloat.SetWindowText("mV");
			m_IDC_COMBO_cbxAICfgCode.SetCurSel(4);
            m_IDC_chkAutoZeroEnable.ShowWindow(SW_SHOW);
            m_IDC_tbxAutoZeroVal.ShowWindow(SW_SHOW);
            m_IDC_cmdSaveAutozeroVal.ShowWindow(SW_SHOW);
            }else{
            iGain = 1;
            m_IDC_chkAutoZeroEnable.ShowWindow(SW_HIDE);
            m_IDC_tbxAutoZeroVal.ShowWindow(SW_HIDE);
            m_IDC_cmdSaveAutozeroVal.ShowWindow(SW_HIDE);
            m_IDC_COMBO_cbxAICfgCode.EnableWindow(true);
			m_IDC_COMBO_cbxAICfgCode.SetCurSel(1);
			OnSelchangeCOMBOcbxAICfgCode();
            m_IDC_optAIFloat.SetWindowText("V");
            //cbxAICfgCode.SelectedIndex = 0;
            //cbxAICfgCode.SelectedIndex = 1;
            }

}

void CAIPollingDlg::OnSelchangeCOMBOcbxAICfgCode() 
{
	CString str;
	// TODO: Add your control notification handler code here
	 switch(m_IDC_COMBO_cbxAICfgCode.GetCurSel())
            {

                case PCIELM4_AI_BI_10V:
                fRangeMax = 10.0F;
                fRangeMin = -10.0F;
                break;

                case PCIELM4_AI_BI_5V:    //1  //Bipolar +/-  5V
                fRangeMax = 5.0F;
                fRangeMin = -5.0F;
                break;

                case PCIELM4_AI_BI_2V5:     //2 //Bipolar +/-  2.5V
                fRangeMax = 2.5F;
                fRangeMin = -2.5F;
                break;

                case PCIELM4_AI_BI_1V25:    //3 //Bipolar +/-  1.25V
                fRangeMax = 1.25F;
                fRangeMin = -1.25F;
                break;

				case 4:
				fRangeMax = 227.3F;
                fRangeMin = -227.3F;
				break;
            }

        YS[0] = (float)(fRangeMax * 1.1);
		str.Format("%.3f",YS[0]);
        m_IDC_yscale0.SetWindowText(str);
        // Convert.ToString(fRangeMax * 1.1);

        YS[1] = (float)(fRangeMin * 1.1);
		str.Format("%.3f",YS[1]);
		m_IDC_yscale1.SetWindowText(str);
        //((TextBox)YScale[1]).Text = Convert.ToString(fRangeMin * 1.1);


        m_IDC_optAIFloat.SetWindowText("V");
}

void CAIPollingDlg::OnSelchangeCOMBOcbxAIRate() 
{
	// TODO: Add your control notification handler code here
	switch (m_IDC_COMBO_cbxAIRate.GetCurSel())
            {

                case 0:
                    lAIRate = PCIELM4_AIRATE_15000;
                    break;
                case 1:
                    lAIRate = PCIELM4_AIRATE_7500;
                    break;
                case 2:
                    lAIRate = PCIELM4_AIRATE_3750;
                    break;
                case 3:
                    lAIRate = PCIELM4_AIRATE_1000;
                    break;
                case 4:
                    lAIRate = PCIELM4_AIRATE_500;
                    break;
                case 5:
                    lAIRate = PCIELM4_AIRATE_30;
                    break;
                case 6:
                    lAIRate = PCIELM4_AIRATE_15;
                    break;


            }
}

void CAIPollingDlg::OnoptAIFloat() 
{
	CString str;
	// TODO: Add your control notification handler code here
	str.Format("%.3f",fRangeMax * 1.1);
	m_IDC_yscale0.SetWindowText(str);

	str.Format("%.3f",fRangeMin * 1.1);
	m_IDC_yscale1.SetWindowText(str);
	m_IDC_optAIHex.SetCheck(0); 
	m_IDC_optAIFloat.SetCheck(1); 	
}

void CAIPollingDlg::OnoptAIHex() 
{
	// TODO: Add your control notification handler code here
	
	m_IDC_yscale0.SetWindowText("0x7FFFFF");
    
	m_IDC_yscale1.SetWindowText("0x800000");
	m_IDC_optAIHex.SetCheck(1); 
	m_IDC_optAIFloat.SetCheck(0); 
}

void CAIPollingDlg::OncmdAITrigger() 
{
	// TODO: Add your control notification handler code here
	//bActive = !bActive;
	m_IDC_cmdAITrigger.EnableWindow(false);
	m_IDC_List1.ResetContent();
	int i;
	CString str;
/*	if(bActive != true )
	{
	    m_IDC_BTN_Active.SetWindowText("&ACTIVE");
		m_IDCCANCEL.EnableWindow(true);
		return;
	}*/

   // m_IDC_BTN_Active.SetWindowText("&STOP");
//	m_IDCCANCEL.EnableWindow(false);
	wBoardNo = m_IDC_COMBO_cbxBoardNo.GetCurSel();
	wChannel = m_IDC_COMBO_cbxAICh.GetCurSel();
	wConfig = m_IDC_COMBO_cbxAICfgCode.GetCurSel();
	if(wConfig == 4){
	wConfig = PCIELM4_AI_BI_227MV;
	}
	dwDataNo = (int)GetDlgItemFloat(IDC_tbxDataNum);
	//Config AI 
	wRtn = PCIELM4_ConfigAI(wBoardNo, 0, 0, 0, 0, 0);
 

	// TODO: Add your control notification handler code here
	//while(bActive == true )
	//{
		//read data to fBuffer
	if (m_IDC_optAIHex.GetCheck() == 1)
	{
		wRtn = PCIELM4_PollingAIH(wBoardNo, wChannel, wConfig, lAIRate, dwDataNo , lBuf);

		for (i = 0 ; i <=  ((int)dwDataNo - 1) ; i++){
			if ((lBuf[i] >= 0) && lBuf[i] < 0x800000 ){
				fBuf[i] = (double)((fRangeMax - fRangeMin) / 2) * ((double)(lBuf[i]) / (double)(0x7FFFFF));
            }else{
                fBuf[i] = (double)((fRangeMax - fRangeMin) / 2) * ((double)(lBuf[i] - (double)(0xFFFFFF)) / (double)(0x7FFFFF));
            }
			if (m_IDC_COMBO_cbxAICh.GetCurSel() < 4 ){
			fBuf[i]=fBuf[i]/1000.0;
			}
        }
		Invalidate();    //update windows
		//Sleep(100);
        //UpdateWindow();  //update windows

	/*	MSG msg;
		if (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
		{
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}*/
	}else
	{
		wRtn = PCIELM4_PollingAI(wBoardNo, wChannel, wConfig, lAIRate, dwDataNo, fBuf);
	}
	if (wRtn != PCIELM4_NoErr)
	{
        MessageBox("AD Polling Error!");
		m_IDC_cmdAITrigger.EnableWindow(true);
        CDialog::OnOK();
	}
	fBuf[0] = fBuf[0] * iGain;

	//List
	if (m_IDC_optAIHex.GetCheck() == 1) {
		str.Format("000  &H%x", lBuf[0]);//
		m_IDC_List1.AddString(str);
            //this.List1.Items.Add("000  &H" + Convert.ToString(lBuf[0]));
		str.Format("%x", lBuf[0]);
        m_IDC_tbxAutoZeroVal.SetWindowText(str);

        }else{
		str.Format("000  %.3f", fBuf[0]);
		m_IDC_List1.AddString(str);
            //this.List1.Items.Add("000" + "  " + String.Format("{0:00.000}", fBuf[0]));
        }

        for (i = 1 ; i <= ((int)dwDataNo - 1) ;i++){

            fBuf[i] = fBuf[i] * iGain;
            

            if (m_IDC_optAIHex.GetCheck() == 1){
				str.Format("%03d  &H%x", i,lBuf[i]);
				m_IDC_List1.AddString(str);
                //this.List1.Items.Add(String.Format("{0:000}",i)+"  &H" + Convert.ToString(lBuf[i]));

            }else{
				str.Format("%03d  %.3f", i,fBuf[i]);
				m_IDC_List1.AddString(str);
                //this.List1.Items.Add(String.Format("{0:000}",i)+"  " + String.Format("{0:00.000}",fBuf[i]));
                

            }


        }
		//Draw the Wave
		OnPaint();
		Invalidate();    //update windows
		//Sleep(100);
        //UpdateWindow();  //update windows
	//	MSG msg;
		//if (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
		//{
		//	::TranslateMessage(&msg);
		//	::DispatchMessage(&msg);
		//}
//	}
		m_IDC_cmdAITrigger.EnableWindow(true);
}

void CAIPollingDlg::OnchkAutoZeroEnable() 
{
	// TODO: Add your control notification handler code here
	if (m_IDC_chkAutoZeroEnable.GetCheck() == 1){
                wRtn = PCIELM4_ConfigAIAutoZero(wBoardNo, m_IDC_COMBO_cbxAICh.GetCurSel(), 1);
            }else{
                wRtn = PCIELM4_ConfigAIAutoZero(wBoardNo, m_IDC_COMBO_cbxAICh.GetCurSel(), 0);
            }
}

void CAIPollingDlg::OncmdSaveAutozeroVal() 
{
	// TODO: Add your control notification handler code here
	wRtn = PCIELM4_SaveAIAutoZeroVal(wBoardNo, m_IDC_COMBO_cbxAICh.GetCurSel(), lAIRate, GetDlgItemHex(IDC_tbxAutoZeroVal));
	if (m_IDC_chkAutoZeroEnable.GetCheck() == 1){
                wRtn = PCIELM4_ConfigAIAutoZero(wBoardNo, m_IDC_COMBO_cbxAICh.GetCurSel(), 1);
	}
}





void CAIPollingDlg::OnOutputDO() 
{
	// TODO: Add your control notification handler code here
	wBoardNo = m_IDC_COMBO_cbxBoardNo.GetCurSel();
	wRtn = PCIELM4_WriteDO(wBoardNo, GetDlgItemHex(IDC_DOVal));
	if (wRtn != PCIELM4_NoErr)
	{
        MessageBox("Digital Output Error!");
	}
}

void CAIPollingDlg::OnInputDI() 
{
	// TODO: Add your control notification handler code here
	char string[10];
	wBoardNo = m_IDC_COMBO_cbxBoardNo.GetCurSel();
	
	wRtn = PCIELM4_ReadDI(wBoardNo, &InVal);
	if (wRtn != PCIELM4_NoErr)
	{
        MessageBox("Digital Input Error!");
	}
	
	_ltoa( InVal, string, 16 );
	SetDlgItemText(IDC_DIVal, string);
}

void CAIPollingDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnCancel();
}
